searchData={"items":[{"type":"module","title":"JSONOrdered","doc":"A simple struct and encoder for the Elixir 1.18+ [JSON](https://hexdocs.pm/elixir/JSON.html) module that allows you to encode JSON data with the keys in the specified order.\n\nThis is handy for external facing API's where the order of keys makes it easier to reason about the response content.","ref":"JSONOrdered.html"},{"type":"module","title":"Usage - JSONOrdered","doc":"Provide the data as a keyword list to `JSONOrdered.new/1`:\n\n```elixir\nJSONOrdered.new(a: 1, b: 2, c: 3)\n```\n\nWhen the JSON module encodes the data, the order of the keys will be preserved:\n\n```json\n{\n  \"a\": 1,\n  \"b\": 2,\n  \"c\": 3\n}\n```\n\nFor example, in a Phoenix controller, you could do something like:\n\n```elixir\ndef index(conn, _params) do\n  conn\n  |> json(JSONOrdered.new(\n    id: \"123\",\n    name: \"John Doe\",\n    email: \"john.doe@example.com\"\n  ))\nend\n```","ref":"JSONOrdered.html#module-usage"},{"type":"function","title":"JSONOrdered.new/1","doc":"","ref":"JSONOrdered.html#new/1"},{"type":"type","title":"JSONOrdered.t/0","doc":"","ref":"JSONOrdered.html#t:t/0"},{"type":"extras","title":"JSONOrdered","doc":"# JSONOrdered\n\n[![CI](https://github.com/navinpeiris/json_ordered/actions/workflows/ci.yml/badge.svg)](https://github.com/navinpeiris/json_ordered/actions/workflows/ci.yml)\n[![Hex version](https://img.shields.io/hexpm/v/json_ordered.svg \"Hex version\")](https://hex.pm/packages/json_ordered)\n[![Hex downloads](https://img.shields.io/hexpm/dt/json_ordered.svg \"Hex downloads\")](https://hex.pm/packages/json_ordered)\n[![License](http://img.shields.io/:license-mit-blue.svg)](http://doge.mit-license.org)\n\nA simple struct and encoder for the Elixir 1.18+ [JSON](https://hexdocs.pm/elixir/JSON.html) module that allows you to encode JSON data with the keys in the specified order.\n\nThis is handy for external facing API's where the order of keys makes it easier to reason about the response content.","ref":"readme.html"},{"type":"extras","title":"Installation - JSONOrdered","doc":"```elixir\ndef deps do\n  [\n    {:json_ordered, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - JSONOrdered","doc":"Provide the data as a keyword list to `JSONOrdered.new/1`:\n\n```elixir\nJSONOrdered.new(a: 1, b: 2, c: 3)\n```\n\nWhen the JSON module encodes the data, the order of the keys will be preserved:\n\n```json\n{\n  \"a\": 1,\n  \"b\": 2,\n  \"c\": 3\n}\n```\n\nFor example, in a Phoenix controller, you could do something like:\n\n```elixir\ndef index(conn, _params) do\n  conn\n  |> json(JSONOrdered.new(\n    id: \"123\",\n    name: \"John Doe\",\n    email: \"john.doe@example.com\"\n  ))\nend\n```","ref":"readme.html#usage"},{"type":"extras","title":"Development - JSONOrdered","doc":"Use the following mix task before pushing commits to run the same checks that are run in CI:\n\n```\nmix ci\n```","ref":"readme.html#development"},{"type":"extras","title":"License - JSONOrdered","doc":"The MIT License\n\nCopyright (c) 2025-present Navin Peiris\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}